import { BaseEvent } from '#application/base/baseEvent'
import CharacterAttackService from '#services/characterAttackService'

export default class CharacterMove extends BaseEvent {
  private readonly characterAttackService = CharacterAttackService

  public listen(): void {
    this.socket.on('map:character:attack', this.handleEvent.bind(this))
  }

  private async handleEvent(data: any, callback: (response: any) => void): Promise<void> {
    try {
      console.log('attack', this.socket.characterId)
      await this.characterAttackService.attack(this.socket.characterId!)
    } catch (error) {
      this.logger.error('map:character:attack error', error)
      return callback(false)
    }
  }
}